package at.ac.uibk.gitsearch.domain.vocabulary;

import com.fasterxml.jackson.annotation.JsonProperty;
import java.util.Arrays;
import java.util.UUID;
import java.util.stream.Collectors;

public class VocabularyItem {

    private String createdOn;
    private UUID uuid;
    private VocabularyItem.LanguageItem[] languageItem;

    public static class LanguageItem {

        private String languageCode;
        private String title;
        private String description;

        @JsonProperty("language_code")
        public String getLanguageCode() {
            return languageCode;
        }

        public void setLanguageCode(String languageCode) {
            this.languageCode = languageCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }

        public String getTitle() {
            return title;
        }

        public void setTitle(String title) {
            this.title = title;
        }
    }

    @JsonProperty("created_on")
    public String getCreatedOn() {
        return createdOn;
    }

    public void setCreatedOn(String createdOn) {
        this.createdOn = createdOn;
    }

    public UUID getUuid() {
        return uuid;
    }

    public void setUuid(UUID uuid) {
        this.uuid = uuid;
    }

    @JsonProperty("text")
    public VocabularyItem.LanguageItem[] getLanguageItem() {
        return languageItem.clone();
    }

    public void setLanguageItem(VocabularyItem.LanguageItem[] languageItem) {
        this.languageItem = languageItem.clone();
    }

    @Override
    public String toString() {
        if (languageItem == null) {
            return "VocabularyItem []";
        }
        return Arrays.stream(languageItem).map(li -> String.format("%s: %s", li.languageCode, li.title)).collect(Collectors.joining(", "));
    }
}
