import { ComponentFixture, TestBed } from '@angular/core/testing';
import { HttpHeaders, HttpResponse } from '@angular/common/http';
import { HttpClientTestingModule } from '@angular/common/http/testing';
import { of } from 'rxjs';

import { ReviewRatingService } from '../service/review-rating.service';

import { ReviewRatingComponent } from './review-rating.component';

describe('ReviewRating Management Component', () => {
  let comp: ReviewRatingComponent;
  let fixture: ComponentFixture<ReviewRatingComponent>;
  let service: ReviewRatingService;

  beforeEach(() => {
    TestBed.configureTestingModule({
      imports: [HttpClientTestingModule],
      declarations: [ReviewRatingComponent],
    })
      .overrideTemplate(ReviewRatingComponent, '')
      .compileComponents();

    fixture = TestBed.createComponent(ReviewRatingComponent);
    comp = fixture.componentInstance;
    service = TestBed.inject(ReviewRatingService);

    const headers = new HttpHeaders();
    jest.spyOn(service, 'query').mockReturnValue(
      of(
        new HttpResponse({
          body: [{ id: 123 }],
          headers,
        })
      )
    );
  });

  it('Should call load all on init', () => {
    // WHEN
    comp.ngOnInit();

    // THEN
    expect(service.query).toHaveBeenCalled();
    expect(comp.reviewRatings?.[0]).toEqual(expect.objectContaining({ id: 123 }));
  });
});
