import { Component } from '@angular/core';
import { NgbActiveModal } from '@ng-bootstrap/ng-bootstrap';

import { IWatchListEntry } from '../watch-list-entry.model';
import { WatchListEntryService } from '../service/watch-list-entry.service';

@Component({
  templateUrl: './watch-list-entry-delete-dialog.component.html',
})
export class WatchListEntryDeleteDialogComponent {
  watchListEntry?: IWatchListEntry;

  constructor(protected watchListEntryService: WatchListEntryService, protected activeModal: NgbActiveModal) {}

  cancel(): void {
    this.activeModal.dismiss();
  }

  confirmDelete(id: number): void {
    this.watchListEntryService.delete(id).subscribe(() => {
      this.activeModal.close('deleted');
    });
  }
}
